#!/usr/bin/python2

import sys
import os
import taxtree
import sortdict

ReportFileName = sys.argv[1]	# /e/res/covann/tree/cov.taxtree
fRep = open(ReportFileName, "a")

ClassifyFileNames = sys.argv[2:]
REFDIR = os.getenv("SERRATAX_REFDIR", "/serratax_ref")
if REFDIR.endswith("/"):
	REFDIR = REFDIR[:-1]
CovTaxTreeFileName = REFDIR + "/cov.taxtree"
taxtree.Load(CovTaxTreeFileName)

def DoFile(FileName):
	for Line in open(FileName):
		if Line.startswith("QueryTaxId="):
			Fields = Line[:-1].split('=')
			assert len(Fields) == 2
			if Fields[1] == "None":
				return None
			TaxId = int(Fields[1])
			return TaxId
	return None

TaxIds = []
Paths = []
Depths = []
N = len(ClassifyFileNames)
for FileName in ClassifyFileNames:
	TaxId = DoFile(FileName)
	if TaxId != None and TaxId not in TaxIds:
		TaxIds.append(TaxId)
		Path = taxtree.GetPathToRoot(TaxId)
		Paths.append(Path)
		Depths.append(len(Path))

def GetClassifiedTaxId(Name):
	for Node in taxtree.Nodes:
		Name2 = taxtree.NodeToName[Node]
		if Name2 == Name:
			return Node
	return None

Order = sortdict.GetOrderDesc(Depths)
if len(Order) == 0:
	s = "_unclassified_"
	print(s)
	fRep.write(s)
	sys.exit(0)

AllYes = False
if len(Order) > 0:
	AllYes = True
	k0 = Order[0]
	TaxId0 = TaxIds[k0]
	Name0 = taxtree.GetName(TaxId0)
	Path0 = Paths[k0]
	for k in Order[1:]:
		TaxId = TaxIds[k]
		Depth = Depths[k]
		Name = taxtree.GetName(TaxId)
		if Name.startswith("unclassified "):
			Name2 = Name.replace("unclassified ", "")
			TaxId = GetClassifiedTaxId(Name2)
		if not TaxId in Path0:
			AllYes = False

if not AllYes:
	TaxId0 = taxtree.NodeToParent[TaxId0]
	Name = taxtree.NodeToName[TaxId0]

s = str(TaxId0)
s += "\t" + Name0
s += "\t" + taxtree.GetTaxStr(TaxId0)
print(s)

s = "TaxId=" + str(TaxId0)
s += "  " + Name0
s += ", " + taxtree.GetTaxStr(TaxId0)
s += "\n"

fRep.write(s)
